/* LPC1768 peripherals Enable/Disable PCONP register header file */

#ifndef __PCONP_H_
#define __PCONP_H_

/* In PCONP(0,5,11,20,28) bits are Reserved */

/* Disable all Peripherals -->PCONP*/

	#define	Disable_Peripherals()	LPC_SC->PCONP=0

/* Enable/Disable Timer0 Module -->PCONP(1) */

	#define	Enable_TIMER0()		LPC_SC->PCONP|=(1<<1)
	#define	Disable_TIMER0()		LPC_SC->PCONP&=~(1<<1)

/* Enable/Disable Timer1 Module -->PCONP(2) */

	#define	Enable_TIMER1()		LPC_SC->PCONP|=(1<<2)
	#define	Disable_TIMER1()		LPC_SC->PCONP&=~(1<<2)

/* Enable/Disable UART0 Module -->PCONP(3) */

	#define	Enable_UART0()		LPC_SC->PCONP|=(1<<3)
	#define	Disable_UART0()		LPC_SC->PCONP&=~(1<<3)
	
/* Enable/Disable UART1 Module -->PCONP(4) */

	#define	Enable_UART1()		LPC_SC->PCONP|=(1<<4)
	#define	Disable_UART1()		LPC_SC->PCONP&=~(1<<4)

/* Enable/Disable PWM Module -->PCONP(6) */

	#define	Enable_PWM()		LPC_SC->PCONP|=(1<<6)
	#define	Disable_PWM()		LPC_SC->PCONP&=~(1<<6)
	
/* Enable/Disable I2C0 Module -->PCONP(7) */

	#define	Enable_I2C0()		LPC_SC->PCONP|=(1<<7)
	#define	Disable_I2C0()		LPC_SC->PCONP&=~(1<<7)
	
/* Enable/Disable SPI Module -->PCONP(8) */

	#define	Enable_SPI()		LPC_SC->PCONP|=(1<<8)
	#define	Disable_SPI()		LPC_SC->PCONP&=~(1<<8)

/* Enable/Disable RTC Module -->PCONP(9) */

	#define	Enable_RTC_Clock()		LPC_SC->PCONP|=(1<<9)
	#define	Disable_RTC_Clock()		LPC_SC->PCONP&=~(1<<9)

/* Enable/Disable SSP0 Module -->PCONP(10) */

	#define	Enable_SSP0()		LPC_SC->PCONP|=(1<<10)
	#define	Disable_SSP0()		LPC_SC->PCONP&=~(1<<10)	

/* Enable/Disable ADC Module -->PCONP(12) */

	#define	Enable_ADC()		LPC_SC->PCONP|=(1<<12)
	#define	Disable_ADC()		LPC_SC->PCONP&=~(1<<12)	

/* Enable/Disable CAN1 Module -->PCONP(13) */

	#define	Enable_CAN1()		LPC_SC->PCONP|=(1<<13)
	#define	Disable_CAN1()		LPC_SC->PCONP&=~(1<<13)

/* Enable/Disable CAN2 Module -->PCONP(14) */

	#define	Enable_CAN2()		LPC_SC->PCONP|=(1<<14)
	#define	Disable_CAN2()		LPC_SC->PCONP&=~(1<<14)
	
/* Enable/Disable GPIO Module -->PCONP(15) */

	#define	Enable_GPIO()		LPC_SC->PCONP|=(1<<15)
	#define	Disable_GPIO()		LPC_SC->PCONP&=~(1<<15)
	
/* Enable/Disable RIT Module -->PCONP(16) */

	#define	Enable_RIT()		LPC_SC->PCONP|=(1<<16)
	#define	Disable_RIT()		LPC_SC->PCONP&=~(1<<16)
	
/* Enable/Disable MCPWM Module -->PCONP(17) */

	#define	Enable_MCPWM()		LPC_SC->PCONP|=(1<<17)
	#define	Disable_MCPWM()		LPC_SC->PCONP&=~(1<<17)
	
/* Enable/Disable QEI Module -->PCONP(18) */

	#define	Enable_QEI()		LPC_SC->PCONP|=(1<<18)
	#define	Disable_QEI()		LPC_SC->PCONP&=~(1<<18)
	
/* Enable/Disable I2C1 Module -->PCONP(19) */

	#define	Enable_I2C1()		LPC_SC->PCONP|=(1<<19)
	#define	Disable_I2C1()		LPC_SC->PCONP&=~(1<<19)

/* Enable/Disable SSP1 Module -->PCONP(21) */

	#define	Enable_SSP1()		LPC_SC->PCONP|=(1<<21)
	#define	Disable_SSP1()		LPC_SC->PCONP&=~(1<<21)
	
/* Enable/Disable Timer2 Module -->PCONP(22) */

	#define	Enable_TIMER2()		LPC_SC->PCONP|=(1<<22)
	#define	Disable_TIMER2()		LPC_SC->PCONP&=~(1<<22)

/* Enable/Disable Timer3 Module -->PCONP(23) */

	#define	Enable_TIMER3()		LPC_SC->PCONP|=(1<<23)
	#define	Disable_TIMER3()		LPC_SC->PCONP&=~(1<<23)
	
/* Enable/Disable UART2 Module -->PCONP(24) */

	#define	Enable_UART2()		LPC_SC->PCONP|=(1<<24)
	#define	Disable_UART2()		LPC_SC->PCONP&=~(1<<24)
	
/* Enable/Disable UART3 Module -->PCONP(25) */

	#define	Enable_UART3()		LPC_SC->PCONP|=(1<<25)
	#define	Disable_UART3()		LPC_SC->PCONP&=~(1<<25)
	
/* Enable/Disable I2C2 Module -->PCONP(26) */

	#define	Enable_I2C2()		LPC_SC->PCONP|=(1<<26)
	#define	Disable_I2C2()		LPC_SC->PCONP&=~(1<<26)
	
/* Enable/Disable I2S Module -->PCONP(27) */

	#define	Enable_I2S()		LPC_SC->PCONP|=(1<<27)
	#define	Disable_I2S()		LPC_SC->PCONP&=~(1<<27)
	
/* Enable/Disable GPDMA Module -->PCONP(29) */

	#define	Enable_GPDMA()		LPC_SC->PCONP|=(1<<29)
	#define	Disable_GPDMA()		LPC_SC->PCONP&=~(1<<29)
	
/* Enable/Disable Ethernet Module -->PCONP(30) */

	#define	Enable_ENET()		LPC_SC->PCONP|=(1<<30)
	#define	Disable_ENET()		LPC_SC->PCONP&=~(1<<30)
	
/* Enable/Disable USB Module -->PCONP(31) */

	#define	Enable_USB()		LPC_SC->PCONP|=(1ul<<31)
	#define	Disable_USB()		LPC_SC->PCONP&=~(1ul<<31)
	
#endif
